////////////////////////////////////////////////////////////////
//                       Jpeg                 //
////////////////////////////////////////////////////////////////

unit UJpeg;

interface

uses Jpeg,ExtCtrls,Windows,Graphics;

type
     TJpeg =class          //   TJpeg
     private
       FImg   :TImage;                 // 
       FCQ    :longint;                //   (1..100)
       FGray  :boolean;                //  " "
     public
       procedure Clear;                // 
       constructor Create;             //  
       destructor Destroy; override;   //  
       procedure Open(Name:string);    //   Name
       procedure Save(Name:string);    //   Name
       procedure Show(Img:TImage);     //    
       procedure Lock(Img:TImage);     //    
       procedure Run;                  //  
     end;

var  Jpeg :TJpeg;          //   TJpeg

implementation

procedure TJpeg.Clear;  // 
begin
     FImg.Picture.Bitmap.Width:=100;             //    
     FImg.Picture.Bitmap.Height:=100;            //    
     FImg.Canvas.Brush.Color:=RGB(255,255,255);  //  
     FImg.Canvas.FillRect(FImg.Canvas.ClipRect); //  
     FCQ   := 90;                                //    
     FGray := false;                             //  " "
end;

constructor TJpeg.Create;  //  
begin
     FImg   := TImage.Create(nil);  // 
     Clear;
end;

destructor TJpeg.Destroy;  //  
begin
     FImg.Free;
end;

procedure TJpeg.Open(Name:string);  //  
var  jpg :TJpegImage;
begin
     jpg:=TJpegImage.Create;            //   
     jpg.LoadFromFile(Name);            //  Jpeg 
     FImg.Picture.Bitmap.Assign(jpg);   //    
     FCQ:=jpg.CompressionQuality;       //  
     FGray:=jpg.Grayscale;              //  " "
     jpg.free;                          //   
end;

procedure TJpeg.Save(Name:string);  //   Name
var  jpg :TJpegImage;
begin
     jpg:=TJpegImage.Create;            //   
     jpg.Assign(FImg.Picture.Graphic);  //    
     jpg.CompressionQuality:=FCQ;       //   
     jpg.Grayscale:=FGray;              //   " "
     jpg.Compress;                      //  
     jpg.SaveToFile(Name);              //    
     jpg.free;                          //   
end;

procedure TJpeg.Show(Img:TImage);     //    
begin
     if Img<>nil then Img.Picture.Bitmap.Assign(FImg.Picture);
end;

procedure TJpeg.Lock(Img:TImage);     //    
begin
     if Img<>nil then FImg.Picture.Bitmap.Assign(Img.Picture);
end;

procedure TJpeg.Run;  //  
var  L,C   :longint;    // 
     Col   :TColor;     //  
     R,G,B :byte;       // : , , 
begin
     for L:=0 to FImg.Picture.Height-1 do begin
         for C:=0 to FImg.Picture.Width-1 do begin
             Col:=FImg.Canvas.Pixels[C,L];
             R:=GetRValue(Col);  G:=GetGValue(Col);  B:=GetBValue(Col);
             //////    //////
             R:=255-R;  G:=255-G;  B:=255-B;
             /////////////////////////////////////
             Col:=RGB(R,G,B);
             FImg.Canvas.Pixels[C,L]:=Col;
         end;
     end;
end;



initialization
    Jpeg:=TJpeg.Create;  //      Jpeg 
finalization
    Jpeg.Free;           //      Jpeg 
end.
